<?php
/**
 * @package n3tTemplate
 * @author Pavel Poles - n3t.cz
 * @copyright (C) 2010 - 2011 - Pavel Poles - n3t.cz
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );


class plgContentN3tTemplate extends JPlugin
{

	function plgContentN3tTemplate(& $subject, $config)
	{
		parent::__construct($subject, $config); 		
	}
	
	// Joomla 1.5
	function onPrepareContent( &$article, &$params, $limitstart )
	{
	  $this->_proccess($article->text);
	}
  
  // Joomla 1.6	
  public function onContentPrepare($context, &$article, &$params, $page = 0) 	
	{
    $this->_proccess($article->text);
	}
	
	private function _proccess(&$text) 
  {  
    if (strpos($text, '{n3ttemplate') === false) return true;   
    $regex		= '/{n3ttemplate\s+(.*?)}/i';
    preg_match_all($regex, $text, $matches, PREG_SET_ORDER);
		if ($matches){
			foreach ($matches as $match) {
				$id = trim($match[1]);
				$output = $this->_load($id);
				$text = preg_replace("|$match[0]|", addcslashes($output, '\\'), $text, 1);
			}
		}           		
	}
			
	private function _load($id)
	{
	  $id = (int)$id;
	  if ($id) {
      $user = & JFactory::getUser();
      if (JVersion::isCompatible('1.6.0')) 			
  			$access = 'access IN ('.implode(',', $user->getAuthorisedViewLevels()).') ';    
      else 
        $access = 'access<='.$user->get('aid', 0).' ';
        
	    $db =& JFactory::getDBO();
  		$db->setQuery( 'SELECT template '.
        'FROM #__n3ttemplate_templates '.
        'WHERE id='.$id.' AND published=1 AND '.$access );
      return $db->loadResult();        		    
	  }
	  return "";
  }	
}